diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-remote-station-manager.h ns-3.35/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.34/src/wifi/model/wifi-remote-station-manager.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-remote-station-manager.h	2021-10-01 13:26:48.000000000 -0700
@@ -22,6 +22,7 @@
 #define WIFI_REMOTE_STATION_MANAGER_H
 
 #include <array>
+#include <unordered_map>
 #include "ns3/traced-callback.h"
 #include "ns3/object.h"
 #include "ns3/data-rate.h"
@@ -92,6 +93,8 @@
   WifiModeList m_operationalRateSet; //!< operational rate set
   WifiModeList m_operationalMcsSet;  //!< operational MCS set
   Mac48Address m_address;            //!< Mac48Address of the remote station
+  uint16_t m_aid;                    /**< AID of the remote station (unused if this object
+                                          is installed on a non-AP station) */
   WifiRemoteStationInfo m_info;      //!< remote station info
   bool m_dsssSupported;              //!< Flag if DSSS is supported by the remote station
   bool m_erpOfdmSupported;           //!< Flag if ERP OFDM is supported by the remote station
@@ -134,13 +137,13 @@
   };
 
   /**
-   * A vector of WifiRemoteStations
+   * A map of WifiRemoteStations with Mac48Address as key
    */
-  typedef std::vector <WifiRemoteStation *> Stations;
+  using Stations = std::unordered_map <Mac48Address, WifiRemoteStation *, WifiAddressHash>;
   /**
-   * A vector of WifiRemoteStationStates
+   * A map of WifiRemoteStationStates with Mac48Address as key
    */
-  typedef std::vector <WifiRemoteStationState *> StationStates;
+  using StationStates = std::unordered_map <Mac48Address, WifiRemoteStationState *, WifiAddressHash>;
 
   /**
    * Set up PHY associated with this device since it is the object that
@@ -201,6 +204,13 @@
   void SetFragmentationThreshold (uint32_t threshold);
 
   /**
+   * Record the AID of a remote station. Should only be called by APs.
+   *
+   * \param remoteAddress the MAC address of the remote station
+   * \param aid the Association ID
+   */
+  void SetAssociationId (Mac48Address remoteAddress, uint16_t aid);
+  /**
    * Records QoS support of the remote station.
    *
    * \param from the address of the station being recorded
@@ -422,6 +432,13 @@
    */
   bool GetQosSupported (Mac48Address address) const;
   /**
+   * Get the AID of a remote station. Should only be called by APs.
+   *
+   * \param remoteAddress the MAC address of the remote station
+   * \return the Association ID if the station is associated, SU_STA_ID otherwise
+   */
+  uint16_t GetAssociationId (Mac48Address remoteAddress) const;
+  /**
    * Add a given Modulation and Coding Scheme (MCS) index to
    * the set of basic MCS.
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-standards.h ns-3.35/src/wifi/model/wifi-standards.h
--- ns-3.34/src/wifi/model/wifi-standards.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-standards.h	2021-10-01 13:26:48.000000000 -0700
@@ -39,20 +39,8 @@
   WIFI_PHY_STANDARD_80211b,
   /** ERP-OFDM PHY (Clause 19, Section 19.5) */
   WIFI_PHY_STANDARD_80211g,
-  /** OFDM PHY for the 5 GHz band (Clause 17 with 10 MHz channel bandwidth) */
-  /** this value is NS_DEPRECATED_3_32 */
-  WIFI_PHY_STANDARD_80211_10MHZ,
-  /** OFDM PHY for the 5 GHz band (Clause 17 with 5 MHz channel bandwidth) */
-  /** this value is NS_DEPRECATED_3_32 */
-  WIFI_PHY_STANDARD_80211_5MHZ,
   /** OFDM PHY (Clause 17 - amendment for 10 MHz and 5 MHz channels) */
   WIFI_PHY_STANDARD_80211p,
-  /** HT PHY for the 2.4 GHz band (clause 20) */
-  /** this value is NS_DEPRECATED_3_32 */
-  WIFI_PHY_STANDARD_80211n_2_4GHZ,
-  /** HT PHY for the 5 GHz band (clause 20) */
-  /** this value is NS_DEPRECATED_3_32 */
-  WIFI_PHY_STANDARD_80211n_5GHZ,
   /** HT PHY  (clause 20) */
   WIFI_PHY_STANDARD_80211n,
   /** VHT PHY (clause 22) */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-tx-vector.cc ns-3.35/src/wifi/model/wifi-tx-vector.cc
--- ns-3.34/src/wifi/model/wifi-tx-vector.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-tx-vector.cc	2021-10-01 13:26:48.000000000 -0700
@@ -20,6 +20,7 @@
  */
 
 #include "wifi-tx-vector.h"
+#include "wifi-phy-common.h"
 #include "ns3/abort.h"
 
 namespace ns3 {
@@ -116,7 +117,7 @@
     }
   if (IsMu ())
     {
-      NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU (" << staId << ")");
+      NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for MU (" << staId << ")");
       NS_ASSERT (m_muUserInfos.find (staId) != m_muUserInfos.end ());
       return m_muUserInfos.at (staId).mcs;
     }
@@ -172,7 +173,7 @@
 {
   if (IsMu ())
     {
-      NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU (" << staId << ")");
+      NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for MU (" << staId << ")");
       NS_ASSERT (m_muUserInfos.find (staId) != m_muUserInfos.end ());
       return m_muUserInfos.at (staId).nss;
     }
@@ -231,8 +232,8 @@
 void
 WifiTxVector::SetMode (WifiMode mode, uint16_t staId)
 {
-  NS_ABORT_MSG_IF (!IsMu (), "Not an HE MU transmission");
-  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  NS_ABORT_MSG_IF (!IsMu (), "Not a MU transmission");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for MU");
   m_muUserInfos[staId].mcs = mode;
   m_modeInitialized = true;
 }
@@ -276,8 +277,8 @@
 void
 WifiTxVector::SetNss (uint8_t nss, uint16_t staId)
 {
-  NS_ABORT_MSG_IF (!IsMu (), "Not an HE MU transmission");
-  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  NS_ABORT_MSG_IF (!IsMu (), "Not a MU transmission");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for MU");
   m_muUserInfos[staId].nss = nss;
 }
 
@@ -368,26 +369,26 @@
 bool
 WifiTxVector::IsMu (void) const
 {
-  return (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB);
+  return ns3::IsMu (m_preamble);
 }
 
 bool
 WifiTxVector::IsDlMu (void) const
 {
-  return ((m_preamble == WIFI_PREAMBLE_VHT_MU) || (m_preamble == WIFI_PREAMBLE_HE_MU));
+  return ns3::IsDlMu (m_preamble);
 }
 
 bool
 WifiTxVector::IsUlMu (void) const
 {
-  return (m_preamble == WIFI_PREAMBLE_HE_TB);
+  return ns3::IsUlMu (m_preamble);
 }
 
 HeRu::RuSpec
 WifiTxVector::GetRu (uint16_t staId) const
 {
   NS_ABORT_MSG_IF (!IsMu (), "RU only available for MU");
-  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for MU");
   return m_muUserInfos.at (staId).ru;
 }
 
@@ -395,7 +396,7 @@
 WifiTxVector::SetRu (HeRu::RuSpec ru, uint16_t staId)
 {
   NS_ABORT_MSG_IF (!IsMu (), "RU only available for MU");
-  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for MU");
   m_muUserInfos[staId].ru = ru;
 }
 
@@ -410,8 +411,8 @@
 WifiTxVector::SetHeMuUserInfo (uint16_t staId, HeMuUserInfo userInfo)
 {
   NS_ABORT_MSG_IF (!IsMu (), "HE MU user info only available for MU");
-  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
-  NS_ABORT_MSG_IF (userInfo.mcs.GetModulationClass () != WIFI_MOD_CLASS_HE, "Only HE modes authorized for HE MU");
+  NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for MU");
+  NS_ABORT_MSG_IF (userInfo.mcs.GetModulationClass () < WIFI_MOD_CLASS_HE, "Only HE (or newer) modes authorized for MU");
   m_muUserInfos[staId] = userInfo;
   m_modeInitialized = true;
 }
@@ -433,7 +434,6 @@
 std::pair<std::size_t, std::size_t>
 WifiTxVector::GetNumRusPerHeSigBContentChannel (void) const
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE-SIG-B content channels only available for HE MU");
   //MU-MIMO is not handled for now, i.e. one station per RU
 
   if (m_channelWidth == 20)
@@ -518,7 +518,7 @@
     {
       os << " BSS color: " << +v.GetBssColor ();
     }
-  if (v.GetPreambleType () == WIFI_PREAMBLE_HE_TB)
+  if (v.IsUlMu ())
     {
       os << " Length: " << v.GetLength ();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-tx-vector.h ns-3.35/src/wifi/model/wifi-tx-vector.h
--- ns-3.34/src/wifi/model/wifi-tx-vector.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-tx-vector.h	2021-10-01 13:26:48.000000000 -0700
@@ -121,22 +121,22 @@
    * MU PPDU, return the transmission mode (MCS) selected for the transmission
    * to the station identified by the given STA-ID.
    *
-   * \param staId the station ID for HE MU
+   * \param staId the station ID for MU
    * \returns the selected payload transmission mode
    */
   WifiMode GetMode (uint16_t staId = SU_STA_ID) const;
   /**
-  * Sets the selected payload transmission mode
-  *
-  * \param mode the payload WifiMode
-  */
+   * Sets the selected payload transmission mode
+   *
+   * \param mode the payload WifiMode
+   */
   void SetMode (WifiMode mode);
   /**
-  * Sets the selected payload transmission mode for a given STA ID (for HE MU only)
-  *
-  * \param mode
-   * \param staId the station ID for HE MU
-  */
+   * Sets the selected payload transmission mode for a given STA ID (for MU only)
+   *
+   * \param mode
+   * \param staId the station ID for MU
+   */
   void SetMode (WifiMode mode, uint16_t staId);
 
   /**
@@ -202,12 +202,12 @@
    * return the number of spatial streams for the transmission to the station
    * identified by the given STA-ID.
    *
-   * \param staId the station ID for HE MU
+   * \param staId the station ID for MU
    * \returns the number of spatial streams
    */
   uint8_t GetNss (uint16_t staId = SU_STA_ID) const;
   /**
-   * \returns the maximum number of Nss (namely if HE MU)
+   * \returns the maximum number of Nss (namely if MU)
    */
   uint8_t GetNssMax (void) const;
   /**
@@ -217,10 +217,10 @@
    */
   void SetNss (uint8_t nss);
   /**
-   * Sets the number of Nss for HE MU
+   * Sets the number of Nss for MU
    *
    * \param nss the number of spatial streams
-   * \param staId the station ID for HE MU
+   * \param staId the station ID for MU
    */
   void SetNss (uint8_t nss, uint16_t staId);
   /**
@@ -319,7 +319,7 @@
   bool IsUlMu (void) const;
   /**
     * Get the RU specification for the STA-ID.
-    * This is applicable only for HE MU.
+    * This is applicable only for MU.
     *
     * \param staId the station ID
     * \return the RU specification for the STA-ID
@@ -327,7 +327,7 @@
    HeRu::RuSpec GetRu (uint16_t staId) const;
    /**
     * Set the RU specification for the STA-ID.
-    * This is applicable only for HE MU.
+    * This is applicable only for MU.
     *
     * \param ru the RU specification
     * \param staId the station ID
@@ -365,7 +365,7 @@
    HeMuUserInfoMap& GetHeMuUserInfoMap (void);
    /**
     * Get the number of RUs per HE-SIG-B content channel.
-    * This is applicable only for HE MU. MU-MIMO (i.e. multiple stations
+    * This is applicable only for MU. MU-MIMO (i.e. multiple stations
     * per RU) is not supported yet.
     * See section 27.3.10.8.3 of IEEE 802.11ax draft 4.0.
     *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-utils.cc ns-3.35/src/wifi/model/wifi-utils.cc
--- ns-3.34/src/wifi/model/wifi-utils.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-utils.cc	2021-10-01 13:26:48.000000000 -0700
@@ -18,16 +18,12 @@
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
 
-#include "ns3/nstime.h"
+#include <cmath>
+#include "ns3/packet.h"
 #include "wifi-utils.h"
 #include "ctrl-headers.h"
 #include "wifi-mac-header.h"
 #include "wifi-mac-trailer.h"
-#include "wifi-net-device.h"
-#include "ns3/ht-configuration.h"
-#include "ns3/he-configuration.h"
-#include "wifi-mode.h"
-#include "ampdu-subframe-header.h"
 
 namespace ns3 {
 
@@ -55,111 +51,6 @@
   return 10.0 * std::log10 (ratio);
 }
 
-uint16_t
-ConvertGuardIntervalToNanoSeconds (WifiMode mode, const Ptr<WifiNetDevice> device)
-{
-  uint16_t gi = 800;
-  if (mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
-    {
-      Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration ();
-      NS_ASSERT (heConfiguration); //If HE modulation is used, we should have a HE configuration attached
-      gi = static_cast<uint16_t> (heConfiguration->GetGuardInterval ().GetNanoSeconds ());
-    }
-  else if (mode.GetModulationClass () == WIFI_MOD_CLASS_HT || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT)
-    {
-      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
-      NS_ASSERT (htConfiguration); //If HT/VHT modulation is used, we should have a HT configuration attached
-      gi = htConfiguration->GetShortGuardIntervalSupported () ? 400 : 800;
-    }
-  return gi;
-}
-
-uint16_t
-ConvertGuardIntervalToNanoSeconds (WifiMode mode, bool htShortGuardInterval, Time heGuardInterval)
-{
-  uint16_t gi;
-  if (mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
-    {
-      gi = static_cast<uint16_t> (heGuardInterval.GetNanoSeconds ());
-    }
-  else if (mode.GetModulationClass () == WIFI_MOD_CLASS_HT || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT)
-    {
-      gi = htShortGuardInterval ? 400 : 800;
-    }
-  else
-    {
-      gi = 800;
-    }
-  return gi;
-}
-
-uint16_t
-GetChannelWidthForTransmission (WifiMode mode, uint16_t maxSupportedChannelWidth)
-{
-  WifiModulationClass modulationClass = mode.GetModulationClass ();
-  if (maxSupportedChannelWidth > 20
-      && (modulationClass == WifiModulationClass::WIFI_MOD_CLASS_OFDM // all non-HT OFDM control and management frames
-          || modulationClass == WifiModulationClass::WIFI_MOD_CLASS_ERP_OFDM)) // special case of beacons at 2.4 GHz
-    {
-      return 20;
-    }
-  //at 2.4 GHz basic rate can be non-ERP DSSS
-  if (modulationClass == WifiModulationClass::WIFI_MOD_CLASS_DSSS
-      || modulationClass == WifiModulationClass::WIFI_MOD_CLASS_HR_DSSS)
-    {
-      return 22;
-    }
-  return maxSupportedChannelWidth;
-}
-
-WifiPreamble
-GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble)
-{
-  if (modulation == WIFI_MOD_CLASS_HE)
-    {
-      return WIFI_PREAMBLE_HE_SU;
-    }
-  else if (modulation == WIFI_MOD_CLASS_VHT)
-    {
-      return WIFI_PREAMBLE_VHT_SU;
-    }
-  else if (modulation == WIFI_MOD_CLASS_HT)
-    {
-      return WIFI_PREAMBLE_HT_MF; // HT_GF has been removed
-    }
-  else if (modulation == WIFI_MOD_CLASS_HR_DSSS && useShortPreamble) //ERP_DSSS is modeled through HR_DSSS (since same preamble and modulation)
-    {
-      return WIFI_PREAMBLE_SHORT;
-    }
-  else
-    {
-      return WIFI_PREAMBLE_LONG;
-    }
-}
-
-bool
-IsAllowedControlAnswerModulationClass (WifiModulationClass modClassReq, WifiModulationClass modClassAnswer)
-{
-  switch (modClassReq)
-    {
-    case WIFI_MOD_CLASS_DSSS:
-      return (modClassAnswer == WIFI_MOD_CLASS_DSSS);
-    case WIFI_MOD_CLASS_HR_DSSS:
-      return (modClassAnswer == WIFI_MOD_CLASS_DSSS || modClassAnswer == WIFI_MOD_CLASS_HR_DSSS);
-    case WIFI_MOD_CLASS_ERP_OFDM:
-      return (modClassAnswer == WIFI_MOD_CLASS_DSSS || modClassAnswer == WIFI_MOD_CLASS_HR_DSSS || modClassAnswer == WIFI_MOD_CLASS_ERP_OFDM);
-    case WIFI_MOD_CLASS_OFDM:
-      return (modClassAnswer == WIFI_MOD_CLASS_OFDM);
-    case WIFI_MOD_CLASS_HT:
-    case WIFI_MOD_CLASS_VHT:
-    case WIFI_MOD_CLASS_HE:
-      return true;
-    default:
-      NS_FATAL_ERROR ("Modulation class not defined");
-      return false;
-    }
-}
-
 uint32_t
 GetAckSize (void)
 {
@@ -250,45 +141,4 @@
   return size;
 }
 
-Time
-GetPpduMaxTime (WifiPreamble preamble)
-{
-  Time duration;
-
-  switch (preamble)
-    {
-      case WIFI_PREAMBLE_HT_MF:
-      case WIFI_PREAMBLE_VHT_SU:
-      case WIFI_PREAMBLE_VHT_MU:
-      case WIFI_PREAMBLE_HE_SU:
-      case WIFI_PREAMBLE_HE_ER_SU:
-      case WIFI_PREAMBLE_HE_MU:
-      case WIFI_PREAMBLE_HE_TB:
-        duration = MicroSeconds (5484);
-        break;
-      default:
-        duration = MicroSeconds (0);
-        break;
-    }
-  return duration;
-}
-
-bool
-IsHt (WifiPreamble preamble)
-{
-   return (preamble == WIFI_PREAMBLE_HT_MF);
-}
-
-bool
-IsVht (WifiPreamble preamble)
-{
-   return (preamble == WIFI_PREAMBLE_VHT_SU || preamble == WIFI_PREAMBLE_VHT_MU);
-}
-
-bool
-IsHe (WifiPreamble preamble)
-{
-   return (preamble == WIFI_PREAMBLE_HE_SU || preamble == WIFI_PREAMBLE_HE_MU || preamble == WIFI_PREAMBLE_HE_TB || preamble == WIFI_PREAMBLE_HE_ER_SU);
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/wifi-utils.h ns-3.35/src/wifi/model/wifi-utils.h
--- ns-3.34/src/wifi/model/wifi-utils.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/wifi-utils.h	2021-10-01 13:26:48.000000000 -0700
@@ -21,18 +21,14 @@
 #ifndef WIFI_UTILS_H
 #define WIFI_UTILS_H
 
-#include "block-ack-type.h"
-#include "wifi-phy-common.h"
-#include "wifi-mode.h"
 #include <list>
+#include "ns3/ptr.h"
+#include "block-ack-type.h"
 
 namespace ns3 {
 
-class WifiNetDevice;
 class WifiMacHeader;
-class WifiMode;
 class Packet;
-class Time;
 
 /**
  * Convert from dBm to Watts.
@@ -67,55 +63,6 @@
  */
 double RatioToDb (double ratio);
 /**
- * Convert the guard interval to nanoseconds based on the WifiMode.
- *
- * \param mode the WifiMode
- * \param device pointer to the WifiNetDevice object
- *
- * \return the guard interval duration in nanoseconds
- */
-uint16_t ConvertGuardIntervalToNanoSeconds (WifiMode mode, const Ptr<WifiNetDevice> device);
-/**
- * Convert the guard interval to nanoseconds based on the WifiMode.
- *
- * \param mode the WifiMode
- * \param htShortGuardInterval whether HT/VHT short guard interval is enabled
- * \param heGuardInterval the HE guard interval duration
- *
- * \return the guard interval duration in nanoseconds
- */
-uint16_t ConvertGuardIntervalToNanoSeconds (WifiMode mode, bool htShortGuardInterval, Time heGuardInterval);
-/**
- * Return the preamble to be used for the transmission.
- *
- * \param modulation the modulation selected for the transmission
- * \param useShortPreamble whether short preamble should be used
- *
- * \return the preamble to be used for the transmission
- */
-WifiPreamble GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble);
-/**
- * Return the channel width that corresponds to the selected mode (instead of
- * letting the PHY's default channel width). This is especially useful when using
- * non-HT modes with HT/VHT/HE capable stations (with default width above 20 MHz).
- *
- * \param mode selected WifiMode
- * \param maxSupportedChannelWidth maximum channel width supported by the PHY layer
- * \return channel width adapted to the selected mode
- */
-uint16_t GetChannelWidthForTransmission (WifiMode mode, uint16_t maxSupportedChannelWidth);
-/**
- * Return whether the modulation class of the selected mode for the
- * control answer frame is allowed.
- *
- * \param modClassReq modulation class of the request frame
- * \param modClassAnswer modulation class of the answer frame
- *
- * \return true if the modulation class of the selected mode for the
- * control answer frame is allowed, false otherwise
- */
-bool IsAllowedControlAnswerModulationClass (WifiModulationClass modClassReq, WifiModulationClass modClassAnswer);
-/**
  * Return the total Ack size (including FCS trailer).
  *
  * \return the total Ack size in bytes
@@ -179,44 +126,6 @@
  * \return the total packet size
  */
 uint32_t GetSize (Ptr<const Packet> packet, const WifiMacHeader *hdr, bool isAmpdu);
-/**
- * Get the maximum PPDU duration (see Section 10.14 of 802.11-2016) for
- * the PHY layers defining the aPPDUMaxTime characteristic (HT, VHT and HE).
- * Return zero otherwise.
- *
- * \param preamble the preamble type
- *
- * \return the maximum PPDU duration, if defined, and zero otherwise
- */
-Time GetPpduMaxTime (WifiPreamble preamble);
-
-/**
- * Return whether the preamble is a HT format preamble.
- *
- * \param preamble the preamble type
- *
- * \return true if the preamble is a HT format preamble,
- *         false otherwise
- */
-bool IsHt (WifiPreamble preamble);
-/**
- * Return whether the preamble is a VHT format preamble.
- *
- * \param preamble the preamble type
- *
- * \return true if the preamble is a VHT format preamble,
- *         false otherwise
- */
-bool IsVht (WifiPreamble preamble);
-/**
- * Return whether the preamble is a HE format preamble.
- *
- * \param preamble the preamble type
- *
- * \return true if the preamble is a HE format preamble,
- *         false otherwise
- */
-bool IsHe (WifiPreamble preamble);
 
 /// Size of the space of sequence numbers
 const uint16_t SEQNO_SPACE_SIZE = 4096;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/yans-error-rate-model.cc ns-3.35/src/wifi/model/yans-error-rate-model.cc
--- ns-3.34/src/wifi/model/yans-error-rate-model.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/yans-error-rate-model.cc	2021-10-01 13:26:48.000000000 -0700
@@ -182,11 +182,7 @@
 YansErrorRateModel::DoGetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits, uint8_t numRxAntennas, WifiPpduField field, uint16_t staId) const
 {
   NS_LOG_FUNCTION (this << mode << txVector << snr << nbits << +numRxAntennas << field << staId);
-  if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_HT
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
+  if (mode.GetModulationClass () >= WIFI_MOD_CLASS_ERP_OFDM)
     {
       uint64_t phyRate;
       if ((txVector.IsMu () && (staId == SU_STA_ID)) || (mode != txVector.GetMode ()))
@@ -356,6 +352,33 @@
                                    5,  // dFree
                                    8,  // adFree
                                    31  // adFreePlusOne
+                                   );
+            }
+        }
+      else if (mode.GetConstellationSize () == 4096)
+        {
+          if (mode.GetCodeRate () == WIFI_CODE_RATE_5_6)
+            {
+              return GetFecQamBer (snr,
+                                   nbits,
+                                   txVector.GetChannelWidth () * 1000000, // signal spread
+                                   mode.GetPhyRate (txVector), //PHY rate
+                                   4096, // m
+                                   4,  // dFree
+                                   14,  // adFree
+                                   69  // adFreePlusOne
+                                   );
+            }
+          else
+            {
+              return GetFecQamBer (snr,
+                                   nbits,
+                                   txVector.GetChannelWidth () * 1000000, // signal spread
+                                   mode.GetPhyRate (txVector), //PHY rate
+                                   4096, // m
+                                   5,  // dFree
+                                   8,  // adFree
+                                   31  // adFreePlusOne
                                    );
             }
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/test/channel-access-manager-test.cc ns-3.35/src/wifi/test/channel-access-manager-test.cc
--- ns-3.34/src/wifi/test/channel-access-manager-test.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/test/channel-access-manager-test.cc	2021-10-01 13:26:48.000000000 -0700
@@ -62,8 +62,6 @@
   void DoDispose (void) override;
   /// \copydoc ns3::Txop::NotifyChannelAccessed
   void NotifyChannelAccessed (Time txopDuration = Seconds (0)) override;
-  /// \copydoc ns3::Txop::NotifyInternalCollision
-  void NotifyInternalCollision (void) override;
   /// \copydoc ns3::Txop::HasFramesToTransmit
   bool HasFramesToTransmit (void) override;
   /// \copydoc ns3::Txop::NotifyChannelSwitching
@@ -165,10 +163,17 @@
  *
  * \brief Frame Exchange Manager Stub
  */
+template <typename TxopType>
 class FrameExchangeManagerStub : public FrameExchangeManager
 {
 public:
-  FrameExchangeManagerStub ()
+  /**
+   * Constructor
+   *
+   * \param test the test channel access manager
+   */
+  FrameExchangeManagerStub (ChannelAccessManagerTest<TxopType> *test)
+    : m_test (test)
   {
   }
   /**
@@ -183,6 +188,14 @@
     dcf->NotifyChannelAccessed ();
     return true;
   }
+  /// \copydoc ns3::FrameExchangeManager::NotifyInternalCollision
+  void NotifyInternalCollision (Ptr<Txop> txop) override
+  {
+    m_test->NotifyInternalCollision (DynamicCast<TxopTest<TxopType>> (txop));
+  }
+
+private:
+  ChannelAccessManagerTest<TxopType> *m_test; //!< the test DCF/EDCA manager
 };
 
 /**
@@ -205,9 +218,9 @@
   void NotifyAccessGranted (uint32_t i);
   /**
    * Notify internal collision function
-   * \param i the index of the Txop
+   * \param state the Txop
    */
-  void NotifyInternalCollision (uint32_t i);
+  void NotifyInternalCollision (Ptr<TxopTest<TxopType>> state);
   /**
    * Generate backoff function
    * \param i the index of the Txop
@@ -365,7 +378,7 @@
 
   typedef std::vector<Ptr<TxopTest<TxopType>>> TxopTests; //!< the TXOP tests typedef
 
-  Ptr<FrameExchangeManagerStub> m_feManager; //!< the Frame Exchange Manager stubbed
+  Ptr<FrameExchangeManagerStub<TxopType>> m_feManager; //!< the Frame Exchange Manager stubbed
   Ptr<ChannelAccessManagerStub> m_ChannelAccessManager; //!< the channel access manager
   TxopTests m_txop; //!< the vector of Txop test instances
   uint32_t m_ackTimeoutValue; //!< the Ack timeout value
@@ -403,13 +416,6 @@
 
 template <typename TxopType>
 void
-TxopTest<TxopType>::NotifyInternalCollision (void)
-{
-  m_test->NotifyInternalCollision (m_i);
-}
-
-template <typename TxopType>
-void
 TxopTest<TxopType>::GenerateBackoff (void)
 {
   m_test->GenerateBackoff (m_i);
@@ -474,9 +480,8 @@
 
 template <typename TxopType>
 void
-ChannelAccessManagerTest<TxopType>::NotifyInternalCollision (uint32_t i)
+ChannelAccessManagerTest<TxopType>::NotifyInternalCollision (Ptr<TxopTest<TxopType>> state)
 {
-  Ptr<TxopTest<TxopType>> state = m_txop[i];
   NS_TEST_EXPECT_MSG_EQ (state->m_expectedInternalCollision.empty (), false, "Have expected internal collisions");
   if (!state->m_expectedInternalCollision.empty ())
     {
@@ -558,7 +563,7 @@
 ChannelAccessManagerTest<TxopType>::StartTest (uint64_t slotTime, uint64_t sifs, uint64_t eifsNoDifsNoSifs, uint32_t ackTimeoutValue)
 {
   m_ChannelAccessManager = CreateObject<ChannelAccessManagerStub> ();
-  m_feManager = CreateObject<FrameExchangeManagerStub> ();
+  m_feManager = CreateObject<FrameExchangeManagerStub<TxopType>> (this);
   m_ChannelAccessManager->SetupFrameExchangeManager (m_feManager);
   m_ChannelAccessManager->SetSlot (MicroSeconds (slotTime));
   m_ChannelAccessManager->SetSifs (MicroSeconds (sifs));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/test/wifi-aggregation-test.cc ns-3.35/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.34/src/wifi/test/wifi-aggregation-test.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/test/wifi-aggregation-test.cc	2021-10-01 13:26:48.000000000 -0700
@@ -192,7 +192,7 @@
   Ptr<const WifiMacQueueItem> peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  WifiMacQueueItem::QueueIteratorPair queueIt;
+  WifiMacQueueItem::ConstIterator queueIt;
   Ptr<WifiMacQueueItem> item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (),
                                                                   true, queueIt);
 
@@ -276,7 +276,7 @@
   peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   txParams.Clear ();
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  queueIt = {nullptr, WifiMacQueue::EMPTY};  // reset queueIt
+  queueIt = WifiMacQueue::EMPTY;  // reset queueIt
   item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true, queueIt);
 
   mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min (), queueIt);
@@ -288,7 +288,7 @@
   peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   txParams.Clear ();
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  queueIt = {nullptr, WifiMacQueue::EMPTY};  // reset queueIt
+  queueIt = WifiMacQueue::EMPTY;  // reset queueIt
   item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (), true, queueIt);
 
   mpduList = mpduAggregator->GetNextAmpdu (item, txParams, Time::Min (), queueIt);
@@ -424,7 +424,7 @@
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
   htFem->TryAddMpdu (peeked, txParams, Time::Min ());
-  WifiMacQueueItem::QueueIteratorPair queueIt;
+  WifiMacQueueItem::ConstIterator queueIt;
   Ptr<WifiMacQueueItem> item = msduAggregator->GetNextAmsdu (peeked, txParams, Time::Min (), queueIt);
 
   bool result = (item != 0);
@@ -451,7 +451,7 @@
 
   NS_TEST_EXPECT_MSG_EQ ((item == 0), true, "A-MSDU aggregation did not fail");
 
-  htFem->DequeueMpdu (*peeked->GetQueueIteratorPairs ().front ().it);
+  htFem->DequeueMpdu (*peeked->GetQueueIterator ());
 
   NS_TEST_EXPECT_MSG_EQ (m_mac->GetBEQueue ()->GetWifiMacQueue ()->GetNPackets (), 0, "queue should be empty");
 
@@ -502,7 +502,7 @@
 
   // Compute the first MPDU to be aggregated in an A-MPDU. It must contain an A-MSDU
   // aggregating two MSDUs
-  queueIt = {nullptr, WifiMacQueue::EMPTY};  // reset queueIt
+  queueIt = WifiMacQueue::EMPTY;  // reset queueIt
   item = m_mac->GetVIQueue ()->GetNextMpdu (peeked, txParams, txopLimit, true, queueIt);
 
   NS_TEST_EXPECT_MSG_EQ (std::distance (item->begin (), item->end ()), 2, "There must be 2 MSDUs in the A-MSDU");
@@ -684,7 +684,7 @@
   Ptr<const WifiMacQueueItem> peeked = m_mac->GetBEQueue ()->PeekNextMpdu ();
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (peeked->GetHeader ());
-  WifiMacQueueItem::QueueIteratorPair queueIt;
+  WifiMacQueueItem::ConstIterator queueIt;
   Ptr<WifiMacQueueItem> item = m_mac->GetBEQueue ()->GetNextMpdu (peeked, txParams, Time::Min (),
                                                                   true, queueIt);
   
